Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_hu.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_hu.ts	(revision 38457)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_hu.ts	(revision 38458)
@@ -236,9 +236,9 @@
     <message>
         <source>Copy all errors to the clipboard</source>
-        <translation type="unfinished"></translation>
+        <translation>Minden hiba vágólapra másolása</translation>
     </message>
     <message>
         <source>Copy</source>
-        <translation type="unfinished">Másolás</translation>
+        <translation>Másolás</translation>
     </message>
 </context>
@@ -390,5 +390,5 @@
     <message>
         <source>ACPI Sh&amp;utdown</source>
-        <translation></translation>
+        <translation>ACPI &amp;leállítás</translation>
     </message>
     <message>
@@ -410,5 +410,5 @@
     <message>
         <source>&amp;View</source>
-        <translation></translation>
+        <translation>&amp;Nézet</translation>
     </message>
     <message>
@@ -751,5 +751,5 @@
     <message>
         <source>Linked Base for %1 and %2</source>
-        <translation type="unfinished"></translation>
+        <translation>Linkelési alap ide: %1 és %2</translation>
     </message>
 </context>
@@ -778,9 +778,9 @@
     <message>
         <source>%1 Clone</source>
-        <translation>%1 Klónozás</translation>
+        <translation>%1 klón</translation>
     </message>
     <message>
         <source>When checked a new unique MAC address will be assigned to all configured network cards.</source>
-        <translation type="unfinished"></translation>
+        <translation>Ha engedélyezett, új egyedi MAC cím lesz minden beállított hálózati kártyához rendelve.</translation>
     </message>
 </context>
@@ -821,17 +821,17 @@
     <message>
         <source>Full Clone</source>
-        <translation type="unfinished"></translation>
+        <translation>Teljes klón</translation>
     </message>
     <message>
         <source>Linked Clone</source>
-        <translation type="unfinished"></translation>
+        <translation>Linkelt klón</translation>
     </message>
     <message>
         <source>&lt;p&gt;Please select the type of the clone.&lt;/p&gt;&lt;p&gt;If you choose &lt;b&gt;Full Clone&lt;/b&gt; an exact copy (including all virtual disk images) of the original VM will be created. If you select &lt;b&gt;Linked Clone&lt;/b&gt;, a new VM will be created, but the virtual disk images will point to the virtual disk images of original VM.&lt;/p&gt;</source>
-        <translation type="unfinished"></translation>
+        <translation>&lt;p&gt;Kérlek válaszd ki a klón típusát.&lt;/p&gt;&lt;p&gt;Ha a &lt;b&gt;Teljes klón&lt;/b&gt;t választod, az eredeti virtuális gép pontos másolata (minden virtuális lemezképpel együtt) fog létrejönni. Ha a &lt;b&gt;Linkelt klón&lt;/b&gt;t választod, egy új virtuális gép jön létre, de a virtuális lemezképek az eredeti virtuális gép lemezképeire fognak mutatni.&lt;/p&gt;</translation>
     </message>
     <message>
         <source>&lt;p&gt;Note that a new snapshot within the source VM is created in case you select &lt;b&gt;Linked Clone&lt;/b&gt;.&lt;/p&gt;</source>
-        <translation type="unfinished"></translation>
+        <translation>&lt;p&gt;Ne feledd, hogy amennyiben &lt;b&gt;Linkelt klón&lt;/b&gt;t választasz, új pillanatkép jön létre a forrás virtuális gépen belül.&lt;/p&gt;</translation>
     </message>
 </context>
@@ -840,33 +840,33 @@
     <message>
         <source>Current machine state</source>
-        <translation type="unfinished">Aktuális gép állapota</translation>
+        <translation>Aktuális gép állapota</translation>
     </message>
     <message>
         <source>Current machine and all child states</source>
-        <translation type="unfinished">Aktuális gép és gyermekei állapota</translation>
+        <translation>Aktuális gép és gyermekei állapota</translation>
     </message>
     <message>
         <source>All states</source>
-        <translation type="unfinished">Minden állapot</translation>
+        <translation>Minden állapot</translation>
     </message>
     <message>
         <source>Cloning Configuration</source>
-        <translation type="unfinished">Klónozási konfiguráció</translation>
+        <translation>Klónozási konfiguráció</translation>
     </message>
     <message>
         <source>Please choose which parts of the virtual machine should be cloned.</source>
-        <translation type="unfinished">Válaszd ki, hogy a virtuális gép melyik részét kell klónozni.</translation>
+        <translation>Válaszd ki, hogy a virtuális gép melyik részét kell klónozni.</translation>
     </message>
     <message>
         <source>If you select &lt;b&gt;Current machine state&lt;/b&gt;, only the current state of the virtual machine is cloned.</source>
-        <translation type="unfinished">Ha az &lt;b&gt;Aktuális gép állapot&lt;/b&gt;át választod, csak a virtuális gép aktuális állapota lesz klónozva.</translation>
+        <translation>Ha az &lt;b&gt;Aktuális gép állapot&lt;/b&gt;át választod, csak a virtuális gép aktuális állapota lesz klónozva.</translation>
     </message>
     <message>
         <source>If you select &lt;b&gt;Current machine and all child states&lt;/b&gt; the current state of the virtual machine and any states of child snapshots are cloned.</source>
-        <translation type="unfinished">Ha az &lt;b&gt;Aktuális gép és gyermekei állapot&lt;/b&gt;át választod, a virtuális gép aktuális állapota és a gyermekek pillanatképeinek minden állapota klónozva lesz.</translation>
+        <translation>Ha az &lt;b&gt;Aktuális gép és gyermekei állapot&lt;/b&gt;át választod, a virtuális gép aktuális állapota és a gyermekek pillanatképeinek minden állapota klónozva lesz.</translation>
     </message>
     <message>
         <source>If you select &lt;b&gt;All states&lt;/b&gt;, the current machine state and all snapshots are cloned.</source>
-        <translation type="unfinished">Ha a &lt;b&gt;Minden állapot&lt;/b&gt;ot választod, az aktuális virtuális gép és minden piialantkép klónozva lesz.</translation>
+        <translation>Ha a &lt;b&gt;Minden állapot&lt;/b&gt;ot választod, az aktuális virtuális gép és minden piialantkép klónozva lesz.</translation>
     </message>
 </context>
@@ -2383,21 +2383,21 @@
     <message>
         <source>Left Shift</source>
-        <translation type="unfinished">Bal Shift</translation>
+        <translation>Bal Shift</translation>
     </message>
     <message>
         <source>Right Shift</source>
-        <translation type="unfinished">Jobb Shift</translation>
+        <translation>Jobb Shift</translation>
     </message>
     <message>
         <source>Left Ctrl</source>
-        <translation type="unfinished">Bal Ctrl</translation>
+        <translation>Bal Ctrl</translation>
     </message>
     <message>
         <source>Right Ctrl</source>
-        <translation type="unfinished">Jobb Ctrl</translation>
+        <translation>Jobb Ctrl</translation>
     </message>
     <message>
         <source>Left Alt</source>
-        <translation type="unfinished">Bal Alt</translation>
+        <translation>Bal Alt</translation>
     </message>
     <message>
@@ -4167,5 +4167,5 @@
     <message>
         <source>When checked the virtual disk will not be removed when the guest system ejects it.</source>
-        <translation type="unfinished">Ha engedélyezed, elnyomja a médium lecsatolását, mikor a vendég rendszer kiadja azt.</translation>
+        <translation>Ha engedélyezed,a virtuális lemez nem lesz eltávolítva, mikor a vendég rendszer kiadja azt.</translation>
     </message>
     <message>
@@ -4175,5 +4175,5 @@
     <message>
         <source>When checked the guest system will see the virtual disk as a solid state device.</source>
-        <translation type="unfinished">Ha engedélyezed, a médium mozgó alkatrészek nélküli tárolóként (SSD) lesz jelölve.</translation>
+        <translation>Ha engedélyezed, a vendég rendszer mozgó alkatrészek nélküli tárolóként (SSD) fogja látni a virtuális lemezt.</translation>
     </message>
     <message>
@@ -4217,5 +4217,5 @@
     <message>
         <source>Selects the port count of the SATA storage controller currently selected in the Storage Tree. This must be at least one more than the highest port number you need to use.</source>
-        <translation type="unfinished">Válaszd ki a Tárolófán jelenleg kiválasztott SATA tárolási vezérlőjének Port értékét. Ez az érték nem lehet kisebb, mint a maximálisan használt portok száma + 1.</translation>
+        <translation>Válaszd ki a Tárolófán jelenleg kiválasztott SATA tárolási vezérlőjének Port értékét. Ez az érték nem lehet kisebb, mint a maximálisan használt portok száma + 1.</translation>
     </message>
 </context>
@@ -4403,5 +4403,5 @@
     <message>
         <source>Selects the chipset to be emulated in this virtual machine. Note that the ICH9 chipset emulation is experimental and not recommended except for guest systems (such as Mac OS X) which require it.</source>
-        <translation type="unfinished">A virtuális gépen használt lapkakészlet típus.</translation>
+        <translation>A virtuális gépen használt lapkakészlet típusa. Ne feledd, hogy az ICH9 lapkakészlet emuláció kísérleti jellegű, és csak olyan vendégrendszerhez ajánlott, melynek szüksége van rá (például Mac OS X).</translation>
     </message>
     <message>
@@ -4437,5 +4437,5 @@
     <message>
         <source>you have assigned ICH9 chipset type to this VM. It will not work properly unless the IO-APIC feature is also enabled. This will be done automatically when you accept the VM Settings by pressing the OK button.</source>
-        <translation type="unfinished"></translation>
+        <translation>az ICH9 lapkakészlet típust választottad a virtuális géphez. Csak akkor fog helyesen működni, ha az IO APIC is be van kapcsolva. Ez automatikusan meg fog történni, mikor az OK gomb megnyomásával elfogadod a beállításokat.</translation>
     </message>
 </context>
@@ -5928,5 +5928,5 @@
     <message>
         <source>The virtual machine that you are changing has been started. Only certain settings can be changed while a machine is running. All other changes will be lost if you close this window now.</source>
-        <translation type="unfinished">A jelenleg szerkesztett virtuális gép állapota megváltozott. Csak a futáskor szerkesztett beállítások lesznek mentve az OK gomb megnyomásakor. Minden egyéb módosítás elveszik.</translation>
+        <translation>A jelenleg szerkesztett virtuális gép állapota megváltozott. Csak bizonyos beállítások módosíthatók a gép futásakor. Minden egyéb módosítás elveszik ezen ablak bezárásakor.</translation>
     </message>
     <message>
@@ -5976,9 +5976,9 @@
     <message>
         <source>Can&apos;t find snapshot named &lt;b&gt;%1&lt;/b&gt;.</source>
-        <translation type="unfinished"></translation>
+        <translation>Nem található a pillanatkép: &lt;b&gt;%1&lt;/b&gt;.</translation>
     </message>
     <message>
         <source>&lt;p&gt;Failed to save the downloaded file as &lt;nobr&gt;&lt;b&gt;%1&lt;/b&gt;.&lt;/nobr&gt;&lt;/p&gt;</source>
-        <translation type="unfinished">&lt;p&gt;Nem sikerült elmenteni a letöltött fájlt ide: &lt;nobr&gt;&lt;b&gt;%1&lt;/b&gt;.&lt;/nobr&gt;&lt;/p&gt;</translation>
+        <translation>&lt;p&gt;Nem sikerült elmenteni a letöltött fájlt: &lt;nobr&gt;&lt;b&gt;%1&lt;/b&gt;.&lt;/nobr&gt;&lt;/p&gt;</translation>
     </message>
 </context>
@@ -6021,9 +6021,9 @@
     <message>
         <source>Cancel the VirtualBox Guest Additions CD image download</source>
-        <translation type="unfinished"></translation>
+        <translation>A VirtualBox Integrációs szolgáltatások CD letöltésének megszakítása</translation>
     </message>
     <message>
         <source>Downloading the VirtualBox Guest Additions CD image from &lt;nobr&gt;&lt;b&gt;%1&lt;/b&gt;...&lt;/nobr&gt;</source>
-        <translation type="unfinished"></translation>
+        <translation>A VirtualBox Integrációs szolgáltatások CD letöltése innen: &lt;nobr&gt;&lt;b&gt;%1&lt;/b&gt;...&lt;/nobr&gt;</translation>
     </message>
 </context>
@@ -6375,5 +6375,5 @@
     <message>
         <source>Please type the name of the new virtual disk file into the box below or click on the folder icon to select a different folder to create the file in.</source>
-        <translation type="unfinished">Nyomd meg a &lt;b&gt;Választ&lt;/b&gt; gombot a virtuális merevlemez elhelyezkedésének megadásához, vagy gépeld be a fájl nevét a mezőbe.</translation>
+        <translation>Kérlek add meg a lenti mezőben az új virtuális lemez nevét, vagy kattints a mappa ikonra a mappa kiválasztásához, ahol létrejöjjön a fájl.</translation>
     </message>
     <message>
@@ -6869,9 +6869,9 @@
     <message>
         <source>Start-up &amp;Disk</source>
-        <translation type="unfinished">Boot &amp;merevlemez</translation>
+        <translation>Indítóle&amp;mez</translation>
     </message>
     <message>
         <source>&lt;p&gt;If you wish you can now add a start-up disk to the new machine. You can either create a new virtual disk or select one from the list or from another location using the folder icon.&lt;/p&gt;&lt;p&gt;If you need a more complex virtual disk setup you can skip this step and make the changes to the machine settings once the machine is created.&lt;/p&gt;</source>
-        <translation type="unfinished">&lt;p&gt;Válaszd ki a merevlemez képfájlt amit boot eszköznek szeretnél használni a virtuális gépben.Készíthetsz új merevlemezt, vagy választhatsz egy létezőt a legördülő menüből,vagy használd a megfelelő gombot (a fájl megnyitása ablak eléréséhez).&lt;/p&gt;&lt;p&gt;Ha ennél bonyolultabb beállítást szeretnél, hagyd ki ezt a lépést, és majd később a virtuális gép beállításaoban csatlakoztass fel a merevlemezt.&lt;/p&gt;</translation>
+        <translation>&lt;p&gt;Most kiválaszthatod az új virtuális gép indítólemezét. Készíthetsz új merevlemezt, vagy választhatsz egy létezőt a listából vagy a mappa ikon használatával kiválasztahtod a helyét.&lt;/p&gt;&lt;p&gt;Ha ennél bonyolultabb beállítást szeretnél, hagyd ki ezt a lépést, és majd később a virtuális gép beállításaoban csatlakoztass fel a merevlemezt.&lt;/p&gt;</translation>
     </message>
     <message>
@@ -6881,5 +6881,5 @@
     <message>
         <source>The recommended size of the start-up disk is &lt;b&gt;%1&lt;/b&gt;.</source>
-        <translation type="unfinished">A boot merevlemezhez ajánlott méret: &lt;b&gt;%1&lt;/b&gt;.</translation>
+        <translation>Az indítólemez ajánlott mérete: &lt;b&gt;%1&lt;/b&gt;.</translation>
     </message>
 </context>
@@ -6917,5 +6917,5 @@
         <source>Start-up Disk</source>
         <comment>summary</comment>
-        <translation type="unfinished">Boot merevlemez</translation>
+        <translation>Indítólemez</translation>
     </message>
     <message>