Index: trunk/src/VBox/Additions/linux/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/linux/Makefile.kmk	(revision 38465)
+++ trunk/src/VBox/Additions/linux/Makefile.kmk	(revision 38466)
@@ -414,5 +414,5 @@
 	$(QUIET)$(MKDIR) -p $(@D)
 ifdef VBOX_USE_PBZIP2
- 	$(QUIET)tar --hard-dereference --owner 0 --group 0 -cRf $(patsubst %.bz2,%,$@) \
+ 	$(QUIET)tar --dereference --owner 0 --group 0 -cRf $(patsubst %.bz2,%,$@) \
  		-C $(VBOX_LNX_ADD_INST_OUT_DIR) \
  		LICENSE bin init lib sbin share src \
@@ -420,5 +420,5 @@
 	$(QUIET)pbzip2 $(patsubst %.bz2,%,$@)
 else
-	$(QUIET)tar --hard-dereference --owner 0 --group 0 --ignore-failed-read -cjRf $@ \
+	$(QUIET)tar --dereference --owner 0 --group 0 --ignore-failed-read -cjRf $@ \
  		-C $(VBOX_LNX_ADD_INST_OUT_DIR) \
  		LICENSE bin init lib sbin share src \
@@ -438,10 +438,10 @@
 	$(QUIET)$(MKDIR) -p $(@D)
 ifdef VBOX_USE_PBZIP2
- 	$(QUIET)tar --hard-dereference --owner 0 --group 0 -cRf $(patsubst %.bz2,%,$@) \
+ 	$(QUIET)tar --dereference --owner 0 --group 0 -cRf $(patsubst %.bz2,%,$@) \
  		-C $(VBOX_LNX_ADD_INST_DBG_DIR) \
  		bin lib sbin
 	$(QUIET)pbzip2 $(patsubst %.bz2,%,$@)
 else
-	$(QUIET)tar --hard-dereference --owner 0 --group 0 --ignore-failed-read -cjRf $@ \
+	$(QUIET)tar --dereference --owner 0 --group 0 --ignore-failed-read -cjRf $@ \
  		-C $(VBOX_LNX_ADD_INST_DBG_DIR) \
  		bin lib sbin
Index: trunk/src/VBox/Frontends/Common/VBoxKeyboard/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/Common/VBoxKeyboard/Makefile.kmk	(revision 38465)
+++ trunk/src/VBox/Frontends/Common/VBoxKeyboard/Makefile.kmk	(revision 38466)
@@ -76,5 +76,5 @@
 	$(QUIET)$(RM) -f -- $@ $(patsubst %.bz2,%,$@)
 ifdef VBOX_GTAR
-	$(QUIET)$(VBOX_GTAR) --hard-dereference --owner 0 --group 0 --ignore-failed-read \
+	$(QUIET)$(VBOX_GTAR) --dereference --owner 0 --group 0 --ignore-failed-read \
 		-cjRf $@ \
  		-C $(PATH_STAGE)/$(VBoxKeyboard-Files_INST).. VBoxKeyboard
Index: trunk/src/VBox/Installer/linux/Makefile.kmk
===================================================================
--- trunk/src/VBox/Installer/linux/Makefile.kmk	(revision 38465)
+++ trunk/src/VBox/Installer/linux/Makefile.kmk	(revision 38466)
@@ -397,9 +397,9 @@
 	$(QUIET)$(MKDIR) -p $(@D)
 ifdef VBOX_USE_PBZIP2
-	$(QUIET)tar --hard-dereference --owner 0 --group 0 \
+	$(QUIET)tar --dereference --owner 0 --group 0 \
 		-cRhf $(patsubst %.bz2,%,$@) -C $(VBOX_LNX_INST_OUT_DIR)/archive $(VBOX_LNX_ARCH_FILES)
 	$(QUIET)pbzip2 $(patsubst %.bz2,%,$@)
 else
-	$(QUIET)tar --hard-dereference --owner 0 --group 0 \
+	$(QUIET)tar --dereference --owner 0 --group 0 \
 		-cjRhf $@ -C $(VBOX_LNX_INST_OUT_DIR)/archive $(VBOX_LNX_ARCH_FILES)
 endif
@@ -414,10 +414,10 @@
 	$(QUIET)$(LN_SYMLINK) $(VBOX_LNX_INST_OUT_DIR)/archive/ $(VBOX_LNX_INST_OUT_DIR)/VirtualBox-$(VBOX_VERSION_STRING)
 ifdef VBOX_USE_PBZIP2
-	$(QUIET)tar --hard-dereference --owner 0 --group 0 \
+	$(QUIET)tar --dereference --owner 0 --group 0 \
 		-cRhf $(patsubst %.bz2,%,$@) -C $(VBOX_LNX_INST_OUT_DIR) \
 		$(addprefix VirtualBox-$(VBOX_VERSION_STRING)/,$(VBOX_LNX_ARCH_FILES))
 	$(QUIET)pbzip2 $(patsubst %.bz2,%,$@)
 else
-	$(QUIET)tar --hard-dereference --owner 0 --group 0 \
+	$(QUIET)tar --dereference --owner 0 --group 0 \
 		-cjRhf $@ -C $(VBOX_LNX_INST_OUT_DIR) \
 		$(addprefix VirtualBox-$(VBOX_VERSION_STRING)/,$(VBOX_LNX_ARCH_FILES))
@@ -489,10 +489,10 @@
 	$(QUIET)$(RM) -f -- $@ $(patsubst %.bz2,%,$@)
 ifdef VBOX_USE_PBZIP2
-	$(QUIET)tar --hard-dereference --owner 0 --group 0 \
+	$(QUIET)tar --dereference --owner 0 --group 0 \
 		-cRhf $(patsubst %.bz2,%,$@) -C $(VBOX_LNX_INST_OUT_DIR)/archive-dbg \
 		$(addprefix $(VBOX_LNX_DBG_PATH)/,$(VBOX_LNX_STRIP_BIN))
 	$(QUIET)pbzip2 $(patsubst %.bz2,%,$@)
 else
-	$(QUIET)tar --hard-dereference --owner 0 --group 0 \
+	$(QUIET)tar --dereference --owner 0 --group 0 \
 		-cjRhf $@ -C $(VBOX_LNX_INST_OUT_DIR)/archive-dbg \
 		$(addprefix $(VBOX_LNX_DBG_PATH)/,$(VBOX_LNX_STRIP_BIN))
Index: trunk/src/VBox/Installer/solaris/Makefile.kmk
===================================================================
--- trunk/src/VBox/Installer/solaris/Makefile.kmk	(revision 38465)
+++ trunk/src/VBox/Installer/solaris/Makefile.kmk	(revision 38466)
@@ -834,5 +834,6 @@
 	$(call MSG_L1,Installing debug binaries $(SOLARIS_DBG_DIR))
 	$(call MSG_L1,Packing $@)
-	$(QUIET)/usr/sfw/bin/gtar --owner 0 --group 0 -cjRhf $(PATH_STAGE_BIN)/$(DBG_ARCHIVE) -C $(SOLARIS_DBG_DIR) $(SOLARIS_DBG_DEPFILES)
+	$(QUIET)/usr/sfw/bin/gtar --dereference --owner 0 --group 0 \
+		-cjRhf $(PATH_STAGE_BIN)/$(DBG_ARCHIVE) -C $(SOLARIS_DBG_DIR) $(SOLARIS_DBG_DEPFILES)
 	$(QUIET)$(CHMOD) 0644 $@
 