Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 38567)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 38568)
@@ -2897,5 +2897,5 @@
         /* Configure User Manual downloader: */
         CVirtualBox vbox = vboxGlobal().virtualBox();
-        pDl->addSource(QString("http://download.virtualbox.org/virtualbox/%1/").arg(vbox.GetVersion().remove(VBOX_BUILD_PUBLISHER)) + strShortFileName);
+        pDl->addSource(QString("http://download.virtualbox.org/virtualbox/%1/").arg(vboxGlobal().vboxVersionStringNormalized()) + strShortFileName);
         pDl->addSource(QString("http://download.virtualbox.org/virtualbox/") + strShortFileName);
         pDl->setTarget(strUserManualFileName2);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp	(revision 38567)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp	(revision 38568)
@@ -374,4 +374,14 @@
            (ct_ver_str.section ('.', 1, 1).toInt() << 8) +
            ct_ver_str.section ('.', 2, 2).toInt();
+}
+
+QString VBoxGlobal::vboxVersionString() const
+{
+    return mVBox.GetVersion();
+}
+
+QString VBoxGlobal::vboxVersionStringNormalized() const
+{
+    return vboxVersionString().remove(VBOX_BUILD_PUBLISHER);
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.h	(revision 38567)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.h	(revision 38568)
@@ -128,4 +128,7 @@
     static uint qtCTVersion();
 
+    QString vboxVersionString() const;
+    QString vboxVersionStringNormalized() const;
+
     QString versionString() const { return mVerString; }
     bool isBeta() const;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/net/UIDownloaderExtensionPack.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/net/UIDownloaderExtensionPack.cpp	(revision 38567)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/net/UIDownloaderExtensionPack.cpp	(revision 38568)
@@ -70,6 +70,6 @@
     QString strTemplateSourcePath("http://download.virtualbox.org/virtualbox/%1/");
     QString strTemplateSourceName("Oracle_VM_VirtualBox_Extension_Pack-%1.vbox-extpack");
-    QString strSourcePath(strTemplateSourcePath.arg(vboxGlobal().virtualBox().GetVersion().remove("_OSE")));
-    QString strSourceName(strTemplateSourceName.arg(vboxGlobal().virtualBox().GetVersion().remove("_OSE")));
+    QString strSourcePath(strTemplateSourcePath.arg(vboxGlobal().vboxVersionStringNormalized()));
+    QString strSourceName(strTemplateSourceName.arg(vboxGlobal().vboxVersionStringNormalized()));
     QString strSource(strSourcePath + strSourceName);
     QString strTargetPath(vboxGlobal().virtualBox().GetHomeFolder());
Index: /trunk/src/VBox/Frontends/VirtualBox/src/net/UIUpdateManager.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/net/UIUpdateManager.cpp	(revision 38567)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/net/UIUpdateManager.cpp	(revision 38568)
@@ -24,4 +24,6 @@
 #include <QDir>
 
+#include <VBox/version.h>
+
 /* Local includes: */
 #include "UIUpdateManager.h"
@@ -131,7 +133,7 @@
 
     /* Get VirtualBox version: */
-    VBoxVersion vboxVersion(vboxGlobal().virtualBox().GetVersion().remove("_OSE"));
+    VBoxVersion vboxVersion(vboxGlobal().vboxVersionStringNormalized());
     /* Get extension pack version: */
-    VBoxVersion expackVersion(extPack.GetVersion().remove("_OSE"));
+    VBoxVersion expackVersion(extPack.GetVersion().remove(VBOX_BUILD_PUBLISHER));
     /* Check if extension pack version less than required: */
     if ((vboxVersion.z() % 2 != 0) /* Skip unstable VBox version */ ||
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 38567)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 38568)
@@ -46,5 +46,4 @@
 /* Global includes */
 #include <iprt/path.h>
-#include <VBox/version.h>
 
 #ifdef VBOX_WITH_DEBUGGER_GUI
@@ -1487,5 +1486,5 @@
     /* Check for the already registered image */
     CVirtualBox vbox = vboxGlobal().virtualBox();
-    const QString &name = QString("VBoxGuestAdditions_%1.iso").arg(vbox.GetVersion().remove(VBOX_BUILD_PUBLISHER));
+    const QString &name = QString("VBoxGuestAdditions_%1.iso").arg(vboxGlobal().vboxVersionStringNormalized());
 
     CMediumVector vec = vbox.GetDVDImages();
@@ -1503,5 +1502,5 @@
     if (result == QIMessageBox::Yes)
     {
-        const QString &source = QString("http://download.virtualbox.org/virtualbox/%1/").arg(vbox.GetVersion().remove(VBOX_BUILD_PUBLISHER)) + name;
+        const QString &source = QString("http://download.virtualbox.org/virtualbox/%1/").arg(vboxGlobal().vboxVersionStringNormalized()) + name;
         const QString &target = QDir(vboxGlobal().virtualBox().GetHomeFolder()).absoluteFilePath(name);
 